//******************************************************************************
//! @file $RCSfile: can_lib.h,v $
//!
//! Copyright (c) 2006 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧ق͈ȉ̊֐ײ؂̌^ϸۂ܂݂܂B
//!		   - CAN()
//!		   - AT90CAN128/64/32p
//!
//! ̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! ̧قAVRStudio-412462/WinAVR-20060125ŊmFĂ܂B
//!
//! @version $Revision: 3.10 $ $Name: jtellier $
//!
//! @todo
//! @bug
//******************************************************************************

#ifndef _CAN_LIB_H_
#define _CAN_LIB_H_

//_____ ݸٰ ________________________________________________________________
#include "can_drv.h"

//_____ ` ___________________________________________________________________

#define CAN_CMD_REFUSED				0xFF	// @brief ̒萔"can_cmd"֐̖߂lƂĎgp܂B
#define CAN_CMD_ACCEPTED			0x00	// @brief ̒萔"can_cmd"֐̖߂lƂĎgp܂B
#define CAN_STATUS_COMPLETED		0x00	// @brief ̒萔"can_get_status"֐̖߂lƂĎgp܂B
#define CAN_STATUS_NOT_COMPLETED	0x01	// @brief ̒萔"can_get_status"֐̖߂lƂĎgp܂B
#define CAN_STATUS_ERROR			0x02	// @brief ̒萔"can_get_status"֐̖߂lƂĎgp܂B

// ----------
// @brief ̗񋓂st_cmd_t\̂Ő錾ꂽүނɑ΂銈IԂ̂Ɏgp܂B
typedef enum {
  CMD_NONE,
  CMD_TX,
  CMD_TX_DATA,
  CMD_TX_REMOTE,
  CMD_RX,
  CMD_RX_DATA,
  CMD_RX_REMOTE,
  CMD_RX_MASKED,
  CMD_RX_DATA_MASKED,
  CMD_RX_REMOTE_MASKED,
  CMD_REPLY,
  CMD_REPLY_MASKED,
  CMD_ABORT
} can_cmd_t;

// ----------
// @brief ̋p̂CANʎq`AWAǧ`ԂŁA܂͕\ʂĂ̱܂B
typedef union{
  U32 ext;
  U16 std;
  U8  tab[4];
} can_id_t; 

// ----------
// @brief ̍\̂RTRޯĂIDEޯĂƂĂ̓`܂B
// (ޯė̈錾͏U16(Ȃ)ŗp\łB)
typedef struct{
  unsigned rtr : 1;
  unsigned ide : 1;
  unsigned dummy :6;
} can_ctrl_t;

// ----------
// @brief ̍\̂CANԂł̓芈̒`܂B
// 1) handle	: ײ؂ɂǗ
// 2) cmd		: IԂ߂ɉpɂď
// 3) id		: Mײ؂ɂ鑗Mŉpɂď
// 4) dlc		: Mײ؂ɂ鑗M̂߂ް^邽߂ɉpɂď
// 5) pt_data	: M܂͎M̂߂ް܂ޕ\߲
// 6) status	: ײ؂ɂǗ
// 7) ctrl		: gڰт}邽߂IDË
typedef  struct{
  U8         handle;
  can_cmd_t  cmd;
  can_id_t   id;
  U8         dlc;
  U8*        pt_data;
  U8         status;
  can_ctrl_t ctrl;
} st_cmd_t;

//_____ 錾 ___________________________________________________________________

//------------------------------------------------------------------------------
//  @fn can_init
//!
//! CANϸۏBCANӋ@\ؾāAޯ ݸޏA񊈓ԂMObu
//! SRMɊ蓖ĂSڼ޽ACANϸۋB
//!
//! @warning	CANϸۂڰъԂƓʂ̒̎MقCAN޽Ōŋ
//!				(ʰ޳@\)B
//!
//! @param	Mode ("can_fixed_baudrate"ҰgpȂ)
//!			0: 葬ްڰĂCANޯ ݸޕ]Jn
//!			1: CANBTڼ޽eCANޯ ݸޕ]Jn
//!
//! @return	ްڰď
//!			0: ޯ ݸތ`Ԑݒ̍莸s
//!			1: ްڰĂ͎s܂B
//!
extern U8 can_init(U8 mode);

//------------------------------------------------------------------------------
//  @fn can_cmd
//!
//! ̊֐͍sׂ(MAMA~)𕪐͂CANLqq܂B
//! ̊֐͑M܂͎MpMObꍇɏ(CAN_CMD_ACCEPTED܂
//! CAN_CMD_REFUSED)Ԃ܂BMObꍇAp͌ōĎsȂ
//! Ȃ܂B
//! ̊֐͑M܂͎MpMObꍇCANLqq(MOB_PENDING
//! MOB_NOT_REACHED)XV܂B~sꂽꍇACANLqqԂ
//! STATUS_CLEAREDɐݒ肳܂B
//!
//! @param	st_cmd_t* - sׂICANLqq\̂Can_descriptor߲
//!
//! @return	CAN_CMD_ACCEPTED - ߂͎󂯓܂B
//!			CAN_CMD_REFUSED  - ߂͋ۂ܂B
//!
extern U8 can_cmd (st_cmd_t *);

//------------------------------------------------------------------------------
//  @fn can_get_status
//!
//! ̊֐͖߂sꂽۂԂƂ܂B
//! M̏ꍇASĂCANүނ\̂Ɋi[܂B
//! ̊֐CANM(MOB_TX_COMPLETED,MOB_RX_COMPLETED,MOB_RX_COMPLETED_DLCW,
//! MOB_???_ERROR)XV܂B
//!
//! @param	st_cmd_t* CANLqq\߲̂
//!
//! @return	CAN_STATUS_COMPLETED		- M܂͎M͊܂B
//!			CAN_STATUS_NOT_COMPLETED	- M܂͎M͊܂łB
//!			CAN_STATUS_ERROR			- `Ԑݒ܂CANʐMłُ̈
//!
extern U8 can_get_status (st_cmd_t *); 

//______________________________________________________________________________

#endif // _CAN_LIB_H_
