//! @file $RCSfile: lin_drv_usart.h,v $
//!
//! Copyright (c) 2004 Atmel.
//!
//! ۸т̎gpATMEL̍ŏIgpҋ_񂪕KvłB
//! 쌠ʒmɂĂlicense.txtǂłB
//!
//! @brief ̧قCĳ ۸яp̐`łB
//!
//! ̐`̧ق͎pDoxygenɂĉ͂邱Ƃł܂B
//! Ȃ۸т̿ĳ\ł̧̂ق̋@\ɒuĂB
//!
//! @version $Revision: 1.1.1.1 $ $Name: First_Release $ $Id: lin_drv_usart.h,v 1.1.1.1 2006/07/27 09:39:53 gallain Exp $
//!
//! @todo
//! @bug

#ifndef _LIN_DRV_H_
#define _LIN_DRV_H_

//_____ ݸٰ ________________________________________________________________

#include "config.h"
#include "lib_mcu/uart/uart_drv.h"
#include "lib_mcu/lin_uart/lin_bdr.h"
#include "lib_mcu/timer/timer2_lib.h"
#include "lib_mcu/lin_uart/runtime_calibration_lib.h"

#if LIN_CONFIG == 1 //1:slave 0:master
#include "lib_mcu/lin_uart/slave_lin.h"
#else
#include "lib_mcu/lin_uart/master_lin.h"
#endif

//_____ ϸ ____________________________________________________________________

//! 
//! @defgroup lin_status_define LINԒl`
//! "_lin_status"ϐpޯĒ`
//! @{
#define MSK_STATUS_RXOK			0x01	// ްM튮׸
#define MSK_STATUS_TXOK			0x02	// ްM튮׸
#define MSK_STATUS_IDOK			0x04	// ʎq튮׸
#define MSK_STATUS_ERR			0x08	// ُ픭׸
#define MSK_STATUS_BSY			0x10	// Z׸
//! @}

//! 
//! @defgroup lin_error_define LINُl`
//! "_lin_err"ϐpޯĒ`
//! @{
#define MSK_STATUS_ERRBIT		0x01	// ޯČ׸
#define MSK_STATUS_ERRCSUM		0x02	// ь׸
#define MSK_STATUS_ERRPARITY	0x04	// è׸
#define MSK_STATUS_ERRSYNCHRO	0x08	// ُ׸
#define MSK_STATUS_TIME_OUT		0x20	// Ԓ߈ُ׸
#define MSK_STATUS_SLEEP_MODE	0x40	// x~׸
//! @}

//! 
//! @defgroup lin_state_define LIN󋵒l`
//! "_lin_state"ϐpޯĒ`
//! @{
#define STATE_CHECK_BREAK		0x00	// f
#define STATE_CHECK_SYNC		0x01	// ޲
#define STATE_ID_TX				0x02	// ʎq޲đM
#define STATE_ID_RX				0x03	// ʎq޲ĎM
#define STATE_DATA_TX			0x04	// ް ޲đM
#define STATE_DATA_RX			0x05	// ް ޲ĎM
#define STATE_CRC_TX			0x06	//  ޲đM
#define STATE_CRC_RX			0x07	//  ޲ĎM
#define STATE_SLEEP				0x08	// x~/N
//! @}

//! 
//! @defgroup lin_command_define LINߒl`
//! LINߕϐpޯĒ`
//! @{
#define LIN_CF_M_TX				0x01	// 呕uM
#define LIN_CF_M_RX				0x02	// 呕uM
#define LIN_CF_S_TX				0x03	// ]uM
#define LIN_CF_S_RX				0x04	// ]uM
#define LIN_CF_S_WKUP			0x05	// N

#define Lin_set_baudrate()	(Uart_set_baudrate(UART_BAUDRATE_SYNC))	//!< LINްڰĐݒ

#define Lin_enable()		(Uart_enable())							//!< USART荞݋

#define Lin_reset_index()	(_lin_index=0)							//! LINwWؾ
#define Lin_inc_index()		(_lin_index++)							//! LINwWis
#define Lin_set_data(data)	(_lin_tab_data[_lin_index] = data, _lin_index++)	//!< LINɏՕްݒ(wWis)
#define Lin_get_data()		(_lin_tab_data[_lin_index])				//!< ݂̎wWLINɏՕް擾
#define Lin_set_id(id)		(_lin_id = id)							//!< LINʎqݒ
#define Lin_get_id()		(_lin_id & 0x3F)						//!< è ޯĂȂLINʎq擾


//! ϸۂ͏]uM߂܂B
//!
//! @param	Ȃ
//!
//! @return	Ȃ
#define Lin_cmds_txdata()  (Lin_set_baudrate(), \
  Uart_set_baudrate(UART_BAUDRATE_NORM), \
    Uart_send_byte(_lin_tab_data[0x00]), \
      _lin_status = MSK_STATUS_BSY, \
        _lin_cmd =LIN_CF_S_TX, \
          _lin_state = STATE_DATA_TX, \
            _lin_cpt = 0x01 , \
              _lin_crc = LIN_CalcChecksum(), \
                _lin_index--)

#define Lin_cmds_rxdata()			(_lin_status = MSK_STATUS_BSY, _lin_cmd =LIN_CF_S_RX)				//!< ]uMߏ
#define Lin_cmds_wkup()				( Uart_set_baudrate(UART_BAUDRATE_NORM), Uart_send_byte(0x80),_lin_status = MSK_STATUS_TXOK)	//!< Nvo
#define Lin_cmd_gotosleep()			( Uart_set_baudrate(UART_BAUDRATE_NORM), _lin_state = STATE_SLEEP)	//! go_to_sleepߑo
#define Lin_get_status()			(_lin_status & 0x1F)												//!< LINԎ擾
#define Lin_get_busy()				(_lin_status & MSK_STATUS_BSY)										//!< Z׸ނ̏Ԏ擾
#define Lin_get_error()				(_lin_err)															//!< LINُ擾
#define Lin_clear_status()			( _lin_status = 0)													//!< LINԉ
#define Lin_clear_error_status()	(_lin_err = 0)														//!< LINُ

//_____ 錾 ___________________________________________________________________

// ϐ̒߂.çقŗp\łB
#if LIN_CONFIG == 0									// 1:]u, 0:呕u
	extern volatile  U8 lin_master_in_sleep_mode;	//!< x~Ԓߔ׸(呕u`Ԃł̎gp̂)
#endif

extern volatile U8  _lin_id;			//!< è ޯĂʎq
extern volatile U8  _lin_tab_data[8];	//!< 8޲ĂްɏՕ
extern volatile U16 _lin_crc;			//!< LIN
extern volatile U8  _lin_index;			//!< ްɏՕ޲Čv
extern volatile U8  _lin_status;		//!< LINԋ@\̏
extern volatile U8  _lin_err;			//!< LINُ
extern volatile U8  _lin_cmd;			//!< LIN݂̖
extern volatile U8  _lin_state;			//!< LINԋ@\Ԕԍ
extern volatile U8  _lin_cpt;			//!< ްɏՕpʒuwq

U8 Lin_dlctonbyte(U8 _lin_id);
void Uart_set_baudrate(U16 expected_baudrate) ;
void Lin_cmdm_txdata(void);
void Lin_cmdm_rxdata(void);

#endif /* _LIN_DRV_H_ */
